#!/usr/bin/perl

open OUT,">unicodedata.h";

print OUT "#ifndef UNICODEDATA_H\n";
print OUT "#define UNICODEDATA_H\n";
print OUT "\n";
print OUT "static unicode_map utf_casemap[] = {\n";

my $isfirst = 1;
open IN,"<UnicodeData.txt";
while(<IN>) {
    m/^(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?);(.*?)$/;
    my $character = lc($1); my $category = $3; my $class = $4; my $ucmap = lc($13); my $lcmap = lc($14); my $tcmap = lc($15);
    my $charname = $2;

    if($lcmap && $ucmap) {

	if($isfirst) {
	    print OUT "\t { 0x$character,0x$ucmap,0x$lcmap,\"$category\" }\t// $charname\n";
	    $isfirst = 0;
	} else {
	    print OUT "\t,{ 0x$character,0x$ucmap,0x$lcmap,\"$category\" }\t// $charname\n";
	}
	
    } elsif($lcmap) {
	
	if($isfirst) {
	    print OUT "\t { 0x$character,0x$character,0x$lcmap,\"$category\" }\t// $charname\n";
	    $isfirst = 0;
	} else {
	    print OUT "\t,{ 0x$character,0x$character,0x$lcmap,\"$category\" }\t// $charname\n";
	}

    } elsif($ucmap) {
	
	if($isfirst) {
	    print OUT "\t { 0x$character,0x$ucmap,0x$character,\"$category\" }\t// $charname\n";
	    $isfirst = 0;
	} else {
	    print OUT "\t,{ 0x$character,0x$ucmap,0x$character,\"$category\" }\t// $charname\n";
	}

    }

}
close IN;

print OUT "};\n";
print OUT "\n";
print OUT "static unicode_specialmap utf_specialmap[] = {\n";

$isfirst = 1;
open IN,"<SpecialCasing.txt";
while(<IN>) {
    #<code>; <lower> ; <title> ; <upper> ; (<condition_list> ;)? # <comment>
    if(!m/^\#/ && m/^(.*?); (.*?); (.*?); (.*?); ((.*?); )?\# (.*?)$/) {
	my $character = lc($1); my $lcmap = lc($2); my $tcmap = lc($3); my $ucmap = lc($4);
	my $condition = lc($6); my $charname = $7;

	if(!$condition) {
	    $ucmap = '0000' if(!$ucmap);
	    $ucmap =~ s/ /,0x/g;
	    $lcmap = '0000' if(!$lcmap);
	    $lcmap =~ s/ /,0x/g;
	    if($isfirst) {
    		print OUT "\t { 0x$character,{0x$ucmap},{0x$lcmap} }\t// $charname\n";
    		$isfirst = 0;
	    } else {
    		print OUT "\t,{ 0x$character,{0x$ucmap},{0x$lcmap} }\t// $charname\n";
	    }
	}
    }
}
close IN;

print OUT "};\n";
print OUT "\n";

print OUT "#endif // UNICODEDATA_H\n";
close OUT;
